import React from 'react';
import { Layout, Menu, Icon } from 'antd';

const { SubMenu } = Menu;
const { Sider } = Layout;

import PubSub from 'pubsub-js';


export default class SiderView extends React.Component {

    constructor(props) {
        super(props);
    }


    $renderItem(db) {

        const{md, config} = db;

        let res = [];
        config.category.forEach((cg, i) => {
            console.log(cg, md)
            const list = md[cg];
            console.log(list);
            const items = list.map((item, i) => {
                return <Menu.Item key={item.page}>{item.page}</Menu.Item>
            });

            res.push((
                    <SubMenu key={cg} title={cg}>
                        {items}
                    </SubMenu>
                ));
        });
        return res;
    }

    componentDidMount() {

        const{md, config} =this.props.db;

        setTimeout(()=> {

            const cg = config.category[0];

            PubSub.publish('SET_PAGE', md[cg][0].page);
        }, 10)
    }

    handleMenuClick({item, key, keyPath}) {
        console.log(item, key);

        PubSub.publish('SET_PAGE', key);

    } 

    render() {

        const menuItems = this.$renderItem(this.props.db);

        return (
                <Menu
                    mode="inline"
                    defaultSelectedKeys={['0']}
                    defaultOpenKeys={['Comp']}
                    style={{ height: '100%' }}
                    onClick={this.handleMenuClick.bind(this)}
                >
                    {menuItems}

                
                </Menu>
        )
    }
}